var com;
if (!com) com = {};
if (!com.yscjp) com.yscjp = {};
if (!com.yscjp.jsapp) com.yscjp.jsapp = {};
if (!com.yscjp.jsapp.ui) com.yscjp.jsapp.ui = {};

com.yscjp.jsapp.ui.ScreenTransition = function () {};

//if (!com.yscjp.jsapp.util) throw new Error("com.yscjp.jsapp.utilが必須です。");

(function() {
    var STYLE_SUFFIX       = "com_yscjp_jsapp_ui_ScreenTransition";
    var STYLE_ID           = STYLE_SUFFIX + "_id_";
    var STYLE_CLASS        = STYLE_SUFFIX + "_class_";
    var STYLE_ID_IFRAME    = STYLE_ID     + "iframe_id_";
    var STYLE_CLASS_IFRAME = STYLE_CLASS  + "iframe";
    var ScreenTransition = com.yscjp.jsapp.ui.ScreenTransition;
    
    /**
     * このスクリプトを実行しているWindow（iframe）の親Windowにiframe要素を作成し、
     * 指定のURLをロードします。
     */
    ScreenTransition.start = function () {
        if (!window.getScreens) {
            throw new Error("必須の関数が存在しません。関数名=window.getScreens");
        }
        if (!window.getTransitionScreen) {
            throw new Error("必須の関数が存在しません。関数名=window.getTransitionScreen");
        }
//        if (!window.frameElement) {
//            throw new Error("このスクリプトは、フレーム内で実行する必要があります。");
//        }
        if (__Private__.iframeList) {
            throw new Error("既にロード済みです。");
        }
        __Private__.iframeList = {};
        __Private__.nameList = [];
        var frameParent;
        if (!window.frameElement) {
            frameParent = document.body;
        } else {
            frameParent = frameElement.parentNode;
        }
        var screens = getScreens();
        __Private__.clearSharedValues();
        for (var i in screens) {
            var targetScreen = screens[i];
            var iframe = __Private__.load(targetScreen.name, targetScreen.url, frameParent);
            var name = targetScreen.name;
            __Private__.iframeList[name] = {};
            __Private__.iframeList[name].url = targetScreen.url;
            __Private__.iframeList[name].iframe = iframe;
            __Private__.iframeList[name].isLoaded = false;
            __Private__.nameList[i] = name;
        }
        var initName = "";
        if (window.getInitName) {
            initName = getInitName();
        }
        if (!initName) {
            initName = __Private__.nameList[0];
        }
        var iframeInfo = __Private__.iframeList[initName];
        if (!iframeInfo) {
            throw new Error("初期表示するフレームの名前が不正です。名前=" + initName);
        }
        iframeInfo.iframe.setAttribute("com_yscjp_jsapp_ui_ScreenTransition_iframe_display", "");
        __Private__.currentName = initName;
    };
    var __Private__ = function () {};
    __Private__.currentName = null;
    __Private__.iframeList = null;
    __Private__.load = function (name, url, frameParent) {
        //console.log("name[" + name + "] url[" + url + "]");
        var targetDocument = frameParent.ownerDocument;
        var iframe = targetDocument.createElement("iframe");
        iframe.actionId = STYLE_ID_IFRAME + name;
        iframe.className = STYLE_CLASS_IFRAME;
        iframe.name = name;
        iframe.src = url + '?' + new Date().getTime();
        iframe.setAttribute("com_yscjp_jsapp_ui_ScreenTransition_iframe_display", "none");
        iframe.addEventListener('load', __Private__.loadHdl, false);
        return frameParent.appendChild(iframe);
    };
    __Private__.loadHdl = function (e) {
        var iframe = e.target;
        //console.log("---------- __Private__.loadHdl["+iframe.name+"] ----------");
        iframe.removeEventListener('load', __Private__.loadHdl, false);
        iframe.contentWindow.getControlPage = __Private__.getControlPage;
        iframe.contentWindow.getTransitionScreen = __Private__.getTransitionScreen;
        iframe.contentWindow.getIFrame = __Private__.getIFrame;
        iframe.contentWindow.transitionScreen = __Private__.transitionScreen;
        iframe.contentWindow.continueTransition = __Private__.continueTransition;
        iframe.contentWindow.getSharedValue = __Private__.getSharedValue;
        iframe.contentWindow.setSharedValue = __Private__.setSharedValue;
        iframe.contentWindow.clearSharedValue = __Private__.clearSharedValue;
        iframe.contentWindow.clearSharedValues = __Private__.clearSharedValues;
        var iframeInfo = __Private__.iframeList[iframe.name];
        if (!iframeInfo) {
            throw new Error("フレームの情報が取得できませんでした。名前=" + iframe.name);
        }
        iframeInfo.isLoaded = true;
        for (var i in __Private__.nameList) {
            var name = __Private__.nameList[i];
            if (!__Private__.iframeList[name].isLoaded) {
                return;
            }
        }
        for (var i in __Private__.nameList) {
            var name = __Private__.nameList[i];
            if (__Private__.iframeList[name].iframe.contentWindow.loadSuccess) {
                __Private__.iframeList[name].iframe.contentWindow.loadSuccess();
            }
        }
    };
    __Private__.getControlPage = function () { return window; };
    __Private__.getTransitionScreen = function (actionId) {
        return getTransitionScreen(actionId);
    };
    __Private__.getIFrame = function (name) {
        if (__Private__.iframeList[name]) {
            return __Private__.iframeList[name].iframe;
        }
        return null;
    };
    __Private__.tempNextScreenInfo;
    __Private__.actionId;
    __Private__.transitionScreen = function (actionId, isSync, effect) {
        var nextScreenInfo = getTransitionScreen(actionId);
        if (!nextScreenInfo) {
            throw new Error("actionIdに該当する名前が存在しません。actionId=" + actionId);
        }
        var nextName = nextScreenInfo.name;
        var currentInfo = __Private__.iframeList[__Private__.currentName];
        var newId = null;
        /*
         * 現在表示中の画面に、pageCloseBeforeが定義されていれば、これを呼び出す。
         */
        if (nextScreenInfo.isCloseBefore && currentInfo.iframe.contentWindow.pageCloseBefore) {
            try {
                newId = currentInfo.iframe.contentWindow.pageCloseBefore(actionId);
            } catch (e) {
                if (currentInfo.iframe.contentWindow.setErrorMessage) {
                    currentInfo.iframe.contentWindow.setErrorMessage(e.message);
                }
                return;
            }
        }
        /*
         * pageCloseBeforeが新しいactionIdを返した場合、このactionIdを遷移先画面のactionIdとする。
         */
        if (newId) {
            actionId = newId;
            nextScreenInfo = getTransitionScreen(actionId);
            if (!nextScreenInfo) {
                throw new Error("pageCloseBeforeが返したIDに該当する名前が存在しません。ID=" + actionId);
            }
            nextName = nextScreenInfo.name;
        }
        var nextInfo = __Private__.iframeList[nextName];
        if (!nextInfo) {
            throw new Error("名前に該当するフレーム情報が存在しません。名前=" + nextName);
        }
        /*
         * 遷移先の画面に、pageOpenBeforeが定義されていれば、これを呼び出す。
         */
        if (nextScreenInfo.isOpenBefore && nextInfo.iframe.contentWindow.pageOpenBefore) {
            try {
                nextInfo.iframe.contentWindow.pageOpenBefore(actionId);
            } catch (e) {
                console.log(e);
                return;
            }
        }
        if (isSync && effect) {
            __Private__.tempNextScreenInfo = nextScreenInfo;
            __Private__.actionId = actionId;
            effect();
        } else {
            __Private__.transitionScreenExec(nextScreenInfo, actionId);
        }
    };
    __Private__.continueTransition = function () {
        var nextScreenInfo = __Private__.tempNextScreenInfo;
        var actionId = __Private__.actionId;
        __Private__.tempNextScreenInfo = null;
        __Private__.transitionScreenExec(nextScreenInfo, actionId);
    };
    __Private__.transitionScreenExec = function (nextScreenInfo, actionId) {
        var currentInfo = __Private__.iframeList[__Private__.currentName];
        var nextName = nextScreenInfo.name;
        var nextInfo = __Private__.iframeList[nextName];
        for (var i in __Private__.nameList) {
            var name = __Private__.nameList[i];
            if (__Private__.iframeList[name]) {
                var namedIFrame = __Private__.iframeList[name].iframe;
                if (name == nextName) {
                    namedIFrame.setAttribute("com_yscjp_jsapp_ui_ScreenTransition_iframe_display", "");
                } else {
                    namedIFrame.setAttribute("com_yscjp_jsapp_ui_ScreenTransition_iframe_display", "none");
                }
            }
        }
        if (nextScreenInfo.isCloseAfter && currentInfo.iframe.contentWindow.pageCloseAfter) {
            currentInfo.iframe.contentWindow.pageCloseAfter(actionId);
        }
        if (nextScreenInfo.isOpenAfter && nextInfo.iframe.contentWindow.pageOpenAfter) {
            nextInfo.iframe.contentWindow.pageOpenAfter(actionId);
        }
        __Private__.currentName = nextName;
    };
    __Private__.sharedValues = {};
    __Private__.sharedValueList = null;
    __Private__.containsKey = function (key) {
        return "undefined" != typeof __Private__.sharedValues[key];
    };
    __Private__.getSharedValue = function (key) {
        return __Private__.sharedValues[key];
    };
    __Private__.setSharedValue = function (key, value) {
        if (!__Private__.containsKey(key)) {
            return;
        }
        __Private__.sharedValues[key] = value;
    };
    __Private__.clearSharedValue = function (key) {
        if (!__Private__.containsKey(key)) {
            return;
        }
        if (window.getSharedValueList) {
            __Private__.sharedValues[key] = getSharedValueList()[key];
        }
    };
    __Private__.clearSharedValues = function () {
        if (window.getSharedValueList) {
            var list = getSharedValueList();
            for (var key in list) {
                var value = list[key].init;
                __Private__.sharedValues[key] = value;
                console.log(key + ':' + value);
            }
        }
    };
})();

